﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DataAccess.Core;

namespace DataAccess.SqlCompact
{
    /// <summary>
    /// Creates a datastore for sql server
    /// </summary>
    public class SqlCompactDataStore : DataStore
    {
        /// <summary>
        /// Creates a new datastore (integrated auth)
        /// </summary>
        /// <param name="Server">the server to connect to</param>
        /// <param name="Catalog">The catalog to use</param>
        public SqlCompactDataStore(string file)
            : this(new SqlCompactConnection(file))
        {
            ExecuteCommands = new SqlCompactExecuteCommands();
        }

        internal SqlCompactDataStore(SqlCompactConnection conn)
            : base(conn)
        {
            ExecuteCommands = new SqlCompactExecuteCommands();
        }
    }
}
