﻿using DataAccess.Core;
using DataAccess.Core.Execute;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;

namespace DataAccess.SqlCompact
{
    public class SqlCompactExecuteCommands : ExecuteCommands
    {
        protected override void InitCommand(System.Data.IDbCommand command, System.Data.IDbConnection conn)
        {
            command.Connection = conn;
        }

        protected override T ExecuteCommand<T>(System.Data.IDbCommand command, Core.Interfaces.IDataConnection connection, Func<System.Data.IDbConnection, T> action)
        {
            T toReturn = default(T);
            foreach (IDbDataParameter parm in command.Parameters)
                connection.DatastoreConverter.CoerceValue(parm);

            IDbConnection conn = connection.GetConnection();
            if (conn.State != ConnectionState.Open)
                conn.Open();

            InitCommand(command, conn);

            try
            {
                toReturn = action(conn);
            }
            catch (Exception e)
            {
                if (conn.State == ConnectionState.Open)
                {
                    command.Dispose();
                    conn.Close();
                }
                throw new QueryException(e, command);
            }
            return toReturn;
        }
    }
}
